const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const playlist_placements = sequelize.define(
    'playlist_placements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

placed_at: {
        type: DataTypes.DATE,
      
      

      },

removed_at: {
        type: DataTypes.DATE,
      
      

      },

position: {
        type: DataTypes.INTEGER,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  playlist_placements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.playlist_placements.belongsTo(db.tracks, {
      as: 'track',
      foreignKey: {
        name: 'trackId',
      },
      constraints: false,
    });

    db.playlist_placements.belongsTo(db.playlists, {
      as: 'playlist',
      foreignKey: {
        name: 'playlistId',
      },
      constraints: false,
    });

    db.playlist_placements.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.playlist_placements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.playlist_placements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return playlist_placements;
};


